<?
define('ROOT','../../../..');
define('TATTERTOOLS_NAME','Tattertools');
define('TATTERTOOLS_VERSION','1.0.6.1');
define('TATTERTOOLS_COPYRIGHT','Copyright © 2004-2006, Tatter & Company');
define('TATTERTOOLS_HOMEPAGE','http://www.tattertools.com/');
define('TATTERTOOLS_SYNC_URL','http://sync.eolin.com/');
define('CRLF',"\r\n");
$database['server']='localhost';
$database['database']='';
$database['username']='';
$database['password']='';
$database['prefix']='';
$service['timeout']=3600;
$service['type']='single';
$service['domain']='';
$service['path']='';
$service['language']='tw';
$service['timezone']='Asia/Taipei';
$service['encoding']='EUC-TW';
$service['umask']=0;
$service['skin']='Tattertools_skyline_tw';
if(@is_numeric($_SERVER['SERVER_PORT'])&&($_SERVER['SERVER_PORT']!=80)&&($_SERVER['SERVER_PORT']!=443))
	$service['port']=$_SERVER['SERVER_PORT'];
function requireComponent($name){
	if(!ereg('^[[:alnum:]]+[[:alnum:].]+$',$name))
		return ;
	include_once ("../../../../components/$name.php");
}
requireComponent('Eolin.PHP.UnifiedEnvironment');
requireComponent('Eolin.PHP.Core');
requireComponent('Tattertools.Core');
requireComponent('Tattertools.Core.BackwardCompatibility');
include_once '../../../../config.php';
function str_tag_on($str){
	$str=str_replace("&amp;","&",$str);
	$str=str_replace("&lt;","<",$str);
	return str_replace("&gt;",">",$str);
}
function xml_parser($url,$mdate){
	if($mdate=="0")
		$mdate="";
	list($header,$body,$lmdate)=@get_remotefile($url,$mdate);
	$st=get_sock_status($header);
	if($st==200){
		$vals=tt_xml_parser_into_struct($body);
	}
	return array($st,$header,$body,$lmdate,$vals);
}
function tt_xml_parser_into_struct($body){
	$h_set=array();
	$r_set=array();
	while($n1=strpos($body,"<![CDATA[")){
		$n2=strpos($body,"]]>");
		if(!$n2||$n1>$n2)
			break;
		$stamp=get_timestamp2();
		$cval=substr($body,$n1+9,$n2-$n1-9);
		$body=str_replace("<![CDATA[".$cval."]]>",$stamp,$body);
		$h_set[$stamp]=trim($cval);
	}
	$b_set=explode("<",$body);
	foreach($b_set as $k=>$row){
		$inp=array();
		$att_set=array();
		$row=trim($row);
		if(!$row)
			continue;
		if(substr($row,0,1)=="/"){
			if(strpos($row,"item")){
				$inp['tag']="ITEM";
				$inp['type']="close";
				array_push($r_set,$inp);
			}
			continue;
		}
		list($tag_inf,$val)=explode(">",$row);
		if($tag_nid=strpos($tag_inf," ")){
			$tag=substr($tag_inf,0,$tag_nid);
			$tag_inf=substr($tag_inf,$tag_nid);
			while($tag_n1=strpos($tag_inf,"=")){
				$tag_n2=strpos($tag_inf,"\"",$tag_n1+2);
				$att_inf=substr($tag_inf,1,$tag_n2);
				$tag_inf=substr($tag_inf,$tag_n2+1);
				$att_var=trim(strtoupper(substr($att_inf,0,$tag_n1-1)));
				$att_val=trim(str_tag_on(str_replace("\"","",substr($att_inf,$tag_n1+1))));
				$att_set[$att_var]=$att_val;
			}
			$inp['attributes']=$att_set;
		}else{
			$tag=$tag_inf;
		}
		if(!$tag||$tag=="?XML")
			continue;
		$tag=strtoupper($tag);
		$inp['tag']=$tag;
		$val=trim($val);
		if(isset($h_set[$val]))
			$val=$h_set[$val];
		elseif($val)
			$val=str_tag_on($val);
		$inp['value']=str_replace("document.cookie","document.&#99;ookie",$val);
		array_push($r_set,$inp);
	}
	return $r_set;
}
function get_remotefile($url,$mdate){
	$url_stuff=parse_url($url);
	if(!$fp=@fsockopen($url_stuff['host'],(($url_stuff['port'])?($url_stuff['port']):("80")),$errno,$errstr,2))
		return false;
	else{
		if($url_stuff['query'])
			$url_stuff['path'].="?";
		$header="GET ".$url_stuff['path'].$url_stuff['query']." HTTP/1.0";
		$header.="\r\nHost: ".$url_stuff['host'];
		$header.="\r\nIf-Modified-Since: $mdate";
		$header.="\r\n\r\n";
		fputs($fp,$header);
		unset($header,$body,$lmdate);
		$act=false;
		$cnt=0;
		socket_set_timeout($fp,4);
		while((!feof($fp))){
			if($cnt==15)
				break;
			$line=fgets($fp,1024);
			$ss=socket_get_status($fp);
			if($ss[timed_out])
				return false;
			if(!$act){
				if(strpos($line,"\r\n",0)==0)
					$act=true;
				if(($n1=strpos($line,"Last-Modified:"))!==false)
					$lmdate=trim(substr($line,$n1+14));
				if(($n2=strpos($line,"Location:"))!==false){
					$loc=trim(substr($line,$n2+9));
					break;
				}
				$header.=$line;
			}else{
				$body.=$line;
				if(strpos($line,"</item>")!==false)
					$cnt++;
			}
		}
		fclose($fp);
	}
	if($loc)
		list($header,$body,$lmdate)=get_remotefile($loc,$mdate);
	return array($header,$body,$lmdate);
}
function get_sock_status($str){
	if(strpos($str,"200 OK"))
		return 200;
	if(strpos($str,"304 Not Modified"))
		return 304;
	else
		return 404;
}
function get_timestamp2(){
	list($usec)=explode(" ",microtime());
	return date("ymdHis",time()).substr($usec,2,6);
}
function str_dbi_check($array){
	if(count($array)){
		while(list($key,$val)=each($array)){
			$array[$key]=str_replace("'","&#39;",$val);
		}
	}
	return $array;
}
function get_siteinfo($xmlinfo){
	foreach($xmlinfo as $k=>$row){
		if(!$st&&$row['tag']=="TITLE")
			$st=$row['value'];
		elseif(!$sl&&$row['tag']=="LINK")
			$sl=$row['value'];
		elseif(!$sd&&$row['tag']=="DESCRIPTION")
			$sd=$row['value'];
		elseif($row['tag']=="ITEM")
			break;
	}
	return array($st,$sl,$sd);
}
function fetchQueryRow($query){
	if($result=mysql_query($query)){
		if($row=mysql_fetch_array($result)){
			mysql_free_result($result);
			return $row;
		}
		mysql_free_result($result);
	}
	return ;
}
function fetchQueryColumn($query){
	$column=array();
	if($result=mysql_query($query)){
		while($row=mysql_fetch_row($result))
			array_push($column,$row[0]);
		mysql_free_result($result);
	}
	return $column;
}
function fetchQueryCell($query){
	if($result=mysql_query($query)){
		list($cell)=mysql_fetch_row($result);
		mysql_free_result($result);
		return $cell;
	}
	return ;
}
mysql_connect($database['server'],$database['username'],$database['password']);
mysql_select_db($database['database']);
if(mysql_query('SET CHARACTER SET utf8')){
	$database['utf8']=true;
}else{
	$database['utf8']=false;
	function mysql_lessen($str,$length=255,$tail='..'){
		return UTF8::lessenAsByte($str,$length,$tail);
	}
}
@mysql_query('SET SESSION collation_connection = \'utf8_general_ci\'');
function getOwner($name){
	global $database;
	return fetchQueryCell("select owner from {$database['prefix']}BlogSettings where name = '$name'");
}
function getOwnerBySecondaryDomain($domain){
	global $database;
	return fetchQueryCell("select owner from {$database['prefix']}BlogSettings where secondaryDomain = '$domain'");
}
function getBlogSetting($owner){
	global $database;
	if($result=mysql_query("select * from {$database['prefix']}BlogSettings where owner = $owner")){
		return mysql_fetch_array($result);
	}
	return false;
}
function getSkinSetting($owner){
	global $database;
	if($result=mysql_query("select * from {$database['prefix']}SkinSettings where owner = $owner"))
		return mysql_fetch_array($result);
	return false;
}
function getBlogURL($name=null,$domain=null,$path=null,$type=null){
	global $service,$blog;
	if($type===null)
		$type=$service['type'];
	if($path===null)
		$path=$service['path'];
	if($domain===null)
		$domain=$service['domain'].(isset($service['port'])?":{$service['port']}":'');
	if($name===null)
		$name=$blog['name'];
	switch($type){
		case 'domain':
			return "http://$name.$domain$path";
		case 'path':
			return "http://$domain$path/$name";
		case 'single':
		default:
			return "http://$domain$path";
	}
}
function correctTTForXmlText($text){
	return str_replace('&quot;','"',str_replace('&#39;','\'',$text));
}
$url=isset($_SERVER['REDIRECT_URL'])?$_SERVER['REDIRECT_URL']:$_SERVER['SCRIPT_NAME'];
$suri=array('url'=>$url,'value'=>'');
$owner=null;
$depth=substr_count($service['path'],'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})(.*)$",$url,$matches))
		$url=$matches[3];
	else
		respondNotFoundPage();
}
if($service['type']=='single'){
	$owner=1;
}else{
	if($service['type']=='domain'){
		if($_SERVER['HTTP_HOST']==$service['domain']){
			$owner=1;
		}else{
			$domain=explode('.',$_SERVER['HTTP_HOST'],2);
			if($domain[1]==$service['domain']){
				$owner=getOwner($domain[0]);
				if($owner===null)
					$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}else{
				$owner=getOwnerBySecondaryDomain($_SERVER['HTTP_HOST']);
			}
		}
	}else{
		if($url=='/'){
			$owner=1;
		}elseif(ereg('^/+([^/]+)(.*)$',$url,$matches)){
			$owner=getOwner($matches[1]);
			$url=$matches[2];
		}else{
			respondNotFoundPage();
		}
	}
	if($owner===null)
		respondNotFoundPage();
}
$blog=getBlogSetting($owner);
$skinSetting=getSkinSetting($owner);
$depth=substr_count(ROOT,'/');
if($depth>0){
	if(ereg("^((/+[^/]+){{$depth}})/*(.*)$",$url,$matches)){
		$suri['directive']=$matches[1];
		if($matches[3]!==false)
			$suri['value']=$matches[3];
	}else
		respondNotFoundPage();
}else{
	$suri['directive']='/';
	$suri['value']=ltrim($url,'/');
}
if(is_numeric($suri['value']))
	$suri['id']=$suri['value'];
$suri['page']=empty($_POST['page'])?(empty($_GET['page'])?true:$_GET['page']):$_POST['page'];
$hostURL="http://{$_SERVER['HTTP_HOST']}".(isset($service['port'])?":{$service['port']}":'');
$blogURL=$service['type']=='path'?"{$service['path']}/{$blog['name']}":$service['path'];
$folderURL=rtrim($blogURL.$suri['directive'],'/');
unset($url,$domain);
if(!file_exists('../../../../config.php')){
	header("Location: $blogURL/setup.php");
	exit;
}
function respondNotFoundPage(){
	header('HTTP/1.1 404 Not Found');
	header("Connection: close");
	exit;
}
function getMicrotimeAsFloat(){
	list($usec,$sec)=explode(" ",microtime());
	return ($usec+$sec);
}
$sessionMicrotime=getMicrotimeAsFloat();
function openSession($savePath,$sessionName){
	return true;
}
function closeSession(){
	return true;
}
function readSession($id){
	global $database,$service;
	if($result=mysql_query("SELECT data FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}' AND updated >= (UNIX_TIMESTAMP() - {$service['timeout']})")){
		if($session=mysql_fetch_array($result))
			return $session['data'];
	}
	return '';
}
function writeSession($id,$data){
	global $database;
	global $sessionMicrotime;
	if(strlen($id)<32)
		return false;
	$userid=isset($_SESSION['userid'])?$_SESSION['userid']:'null';
	$data=mysql_escape_string($data);
	$server=mysql_escape_string($_SERVER['HTTP_HOST']);
	$request=mysql_escape_string($_SERVER['REQUEST_URI']);
	$referer=isset($_SERVER['HTTP_REFERER'])?mysql_escape_string($_SERVER['HTTP_REFERER']):'';
	$timer=getMicrotimeAsFloat()-$sessionMicrotime;
	$result=mysql_query("UPDATE {$database['prefix']}Sessions SET userid = $userid, data = '$data', server = '$server', request = '$request', referer = '$referer', timer = $timer, updated = UNIX_TIMESTAMP() WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	if($result&&(mysql_affected_rows()==1))
		return true;
	return false;
}
function destroySession($id,$setCookie=false){
	global $database;
	if(!isset($_SESSION['userid']))
		return ;
	@mysql_query("DELETE FROM {$database['prefix']}Sessions WHERE id = '$id' AND address = '{$_SERVER['REMOTE_ADDR']}'");
	gcSession();
}
function gcSession($maxLifeTime=false){
	global $database,$service;
	@mysql_query("DELETE FROM {$database['prefix']}Sessions WHERE updated < (UNIX_TIMESTAMP() - {$service['timeout']})");
	$result=@mysql_query("SELECT DISTINCT v.id, v.address FROM {$database['prefix']}SessionVisits v LEFT JOIN {$database['prefix']}Sessions s ON v.id = s.id AND v.address = s.address WHERE s.id IS NULL AND s.address IS NULL");
	if($result){
		$gc=array();
		while($g=mysql_fetch_row($result))
			array_push($gc,$g);
		foreach($gc as $g)
			@mysql_query("DELETE FROM {$database['prefix']}SessionVisits WHERE id = '{$g[0]}' AND address = '{$g[1]}'");
	}
	return true;
}
function getAnonymousSession(){
	global $database;
	$result=mysql_query("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if($result&&(list($id)=mysql_fetch_array($result)))
		return $id;
	return false;
}
function newAnonymousSession(){
	global $database;
	for($i=0;$i<100;$i++){
		if(($id=getAnonymousSession())!==false)
			return $id;
		$id=dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF)).dechex(rand(0x10000000,0x7FFFFFFF));
		mysql_query("INSERT INTO {$database['prefix']}Sessions(id, address, created, updated) VALUES('$id', '{$_SERVER['REMOTE_ADDR']}', UNIX_TIMESTAMP(), UNIX_TIMESTAMP())");
		if(mysql_affected_rows()>0)
			return $id;
	}
	return false;
}
function setSessionAnonymous($currentId){
	$id=getAnonymousSession();
	if($id!==false){
		if($id!=$currentId)
			session_id($id);
		return true;
	}
	$id=newAnonymousSession();
	if($id!==false){
		session_id($id);
		return true;
	}
	return false;
}
function isSessionAuthorized($id){
	global $database;
	$result=mysql_query("select id from {$database['prefix']}Sessions where id = '$id' and address = '{$_SERVER['REMOTE_ADDR']}' and (userid is not null or preexistence is not null)");
	if($result&&(mysql_num_rows($result)==1))
		return true;
	return false;
}
function setSession(){
	$id=empty($_COOKIE[session_name()])?'':$_COOKIE[session_name()];
	if((strlen($id)<32)||!isSessionAuthorized($id))
		setSessionAnonymous($id);
}
session_name('TSSESSION');
setSession();
session_set_save_handler('openSession','closeSession','readSession','writeSession','destroySession','gcSession');
session_cache_expire(1);
session_set_cookie_params(0,'/',$service['domain']);
if(session_start()!==true){
	header('HTTP/1.1 503 Service Unavailable');
}
function requireLogin(){
	global $service,$hostURL,$blogURL;
	if(!empty($service['loginURL']))
		header("Location: {$service['loginURL']}?requestURI=".rawurlencode("$hostURL{$_SERVER['REQUEST_URI']}"));
	else{
		header("Location: $blogURL/login?requestURI=".rawurlencode("{$_SERVER['REQUEST_URI']}"));
	}
	exit;
}
function doesHaveMembership(){
	return empty($_SESSION['userid'])?false:true;
}
function getUserId(){
	return empty($_SESSION['userid'])?false:$_SESSION['userid'];
}
function doesHaveOwnership(){
	global $owner;
	if(empty($_SESSION['userid'])||($_SESSION['userid']!=$owner))
		return false;
	return true;
}
function requireOwnership(){
	if(doesHaveOwnership())
		return true;
	requireLogin();
	return false;
}
if(doesHaveMembership()){
	$user=array('id'=>getUserId());
	list($user['loginid'],$user['name'])=fetchQueryRow("select loginid, name from {$database['prefix']}Users where userid = {$user['id']}");
	list($user['blog'],$user['timezone'])=fetchQueryRow("select name, timezone from {$database['prefix']}BlogSettings where owner = {$user['id']}");
	$user['homepage']=getBlogURL($user['blog']);
}else
	$user=null;
Timezone::set(isset($blog['timezone'])?$blog['timezone']:$service['timezone']);
mysql_query('SET time_zone = \''.Timezone::getCanonical().'\'');
Locale::setDirectory('../../../../language');
Locale::set(isset($blog['language'])?$blog['language']:$service['language']);
$activePlugins=array();
$eventMappings=array();
$tagMappings=array();
if(!empty($owner)){
	$activePlugins=fetchQueryColumn("SELECT name FROM {$database['prefix']}Plugins WHERE owner = $owner");
	$xmls=new XMLStruct();
	foreach($activePlugins as $plugin){
		$manifest=@file_get_contents("../../../../plugins/$plugin/index.xml");
		if($manifest&&$xmls->open($manifest)){
			if($xmls->doesExist('/plugin/binding/listener')){
				foreach($xmls->selectNodes('/plugin/binding/listener') as $listener){
					if(!empty($listener['.attributes']['event'])&&!empty($listener['.value'])){
						if(!isset($eventMappings[$listener['.attributes']['event']]))
							$eventMappings[$listener['.attributes']['event']]=array();
						array_push($eventMappings[$listener['.attributes']['event']],array('plugin'=>$plugin,'listener'=>$listener['.value']));
					}
				}
				unset($listener);
			}
			if($xmls->doesExist('/plugin/binding/tag')){
				foreach($xmls->selectNodes('/plugin/binding/tag') as $tag){
					if(!empty($tag['.attributes']['name'])&&!empty($tag['.attributes']['handler'])){
						if(!isset($tagMappings[$tag['.attributes']['name']]))
							$tagMappings[$tag['.attributes']['name']]=array();
						array_push($tagMappings[$tag['.attributes']['name']],array('plugin'=>$plugin,'handler'=>$tag['.attributes']['handler']));
					}
				}
				unset($tag);
			}
		}else{
			$plugin=mysql_escape_string($plugin);
			mysql_query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner AND name = '$plugin'");
		}
	}
	unset($xmls);
	unset($plugin);
}
header('Content-Type: text/html; charset=utf-8');
requireOwnership();
if(!empty($_GET['rss'])){
	list($st,$header,$body,$lmdate,$rval)=@xml_parser($_GET['rss'],'');
	if($rval){
		list($title,$link)=str_dbi_check(@get_siteinfo($rval));
		if(UTF8::validate($title,true))
			$name=correctTTForXmlText(UTF8::correct(trim($title)));
		else
			$name=correctTTForXmlText(UTF8::bring(trim($title)));
		if(UTF8::validate($link,true))
			$url=correctTTForXmlText(UTF8::correct(trim($link)));
		else
			$url=correctTTForXmlText(UTF8::bring(trim($link)));
		header('Content-Type: text/xml; charset=utf-8');
		print ("<?xml version=\"1.0\" encoding=\"utf-8\"?><response><name>$name</name><url>$url</url></response>");
	}else{
		header('Content-Type: text/xml; charset=utf-8');
		print ("<?xml version=\"1.0\" encoding=\"utf-8\"?><response><name></name><url></url></response>");
	}
}?>